/*
 * Newt-Puzzle
 * Copyright (C) 2008, 2009 <elderme@tuxfamily.org>
 * 
 * Newt-Puzzle is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Newt-Puzzle is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _MATRIX4_H_
#define _MATRIX4_H_

class Matrix4
{
public:
	Matrix4();
	Matrix4(float m00, float m01, float m02, float m03,
     		float m10, float m11, float m12, float m13,
       		float m20, float m21, float m22, float m23,
       		float m30, float m31, float m32, float m33 );

	Matrix4 transpose();			
			
	friend Matrix4 operator*(const Matrix4& m1,const Matrix4& m2);
		
    union {
        float m[4][4];
        float _m[16];
    };
};

#endif // _MATRIX4_H_
